# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.1.0/),
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## [Unreleased]

## [0.1.0-alpha.2] - 2025-04-07

### Added

- Add short documentation on how to use the library ([README.md](./README.md))

### Changed

- `ServiceDescriptor` has been renamed to `Provider`
- Shorthands to create providers has been put as class methods directly into the `Provider` class
- `Registry` public API has been fully replaced by `register` function and `provider` decorator to fit most use cases
- Set as private all internals and core of the library

### Removed

- Removed the `BaseContainer` abstract class which has been merge with the `Container` itself.

### Internals

- Add `PyInvoke` and tasks for managing the project

## [0.1.0-alpha.1]

### Added

- `Registry` - for registering services by type including values, factories, scoped factories, singletons, aliases
- Imperative services registration - through `register`, `register_*` and dict like `reg[Service] = ...` functions
- Declarative services registration - through decorators `@factory`, `@singleton`, `@scoped`
- Manual wiring - lambda can be used as factories with optionally a single argument to receive the container
- Autowiring - The container uses factories and classes constructors arguments type hints to resolve and inject nested dependencies
- `Container` - for resolving services from registry
- `ScopedContainer` - using registry and parent container to resolve services for a scoped lifetime (http request for example)

[unreleased]: https://github.com/g0di/handless/compare/0.1.0-alpha.2...HEAD
[0.1.0-alpha.2]: https://github.com/g0di/handless/compare/0.1.0-alpha.1...0.1.0-alpha.2
[0.1.0-alpha.1]: https://github.com/olivierlacan/keep-a-changelog/releases/tag/0.1.0-alpha.1
